# -*- coding: utf-8 -*-
"""

__author__     = "SifTeam Friend"
__copyright__  = "Copyright 2011-2012"
__credits__    = ["Mona66, KingOfSat"]
__license__    = "GPL"
__version__    = "0.3.0.0"
__daterel__    = "2012-02-09"
__maintainer__ = "SifTeam Friend"
__email__      = "..."

"""

import sys
import array
import urllib
import string 
import time
import os.path
from datetime import date


# attributes
web_urls            = ["http://it.kingofsat.net/tvpack-skyitalia.php", 
                       "http://it.kingofsat.net/tvpack-tivusat.php", 
                       "http://it.kingofsat.net/tvpack-rai.php", 
                       "http://it.kingofsat.net/tvpack-mediaset.php", 
                       "http://it.kingofsat.net/tvpack-cyfra.php", 
                       "http://it.kingofsat.net/tvpack-polsat.php", 
                       "http://it.kingofsat.net/tvpack-n.php", 
                       "http://it.kingofsat.net/tvpack-orangepl.php", 
                       "http://it.kingofsat.net/tvpack-nova.php", 
                       "http://it.kingofsat.net/tvpack-tvnakarte.php", 
                       "http://it.kingofsat.net/tvpack-orange.php", 
                       "http://it.kingofsat.net/tvpack-hellohd.php", 
                       "http://it.kingofsat.net/tvpack-ssr.php", 
                       "http://it.kingofsat.net/tvpack-bis.php", 
                       "http://it.kingofsat.net/tvpack-mtv.php", 
                       "http://it.kingofsat.net/tvpack-totaltv.php", 
                       "http://it.kingofsat.net/tvpack-visiontv.php", 
                       "http://it.kingofsat.net/tvpack-arabesque.php", 
                       "http://it.kingofsat.net/tvpack-aljazeerasport.php", 
                       "http://it.kingofsat.net/tvpack-mobistar.php", 
                       "http://it.kingofsat.net/tvpack-telesat.php", 
                       "http://it.kingofsat.net/tvpack-add.php", 
                       "http://it.kingofsat.net/tvpack-kabelkiosk.php", 
                       "http://it.kingofsat.net/tvpack-ntvrussia.php"]

web_bouquets        = ["Sky Italia", 
                       "TivùSat", 
                       "RAI", 
                       "Mediaset", 
                       "Cyfra +", 
                       "Cyfrowy Polsat", 
                       "N", 
                       "Orange Polska", 
                       "Nova", 
                       "Telewizja na kartę", 
                       "Orange", 
                       "Hello HD", 
                       "SSR/SRG", 
                       "Bis", 
                       "MTV Networks", 
                       "Total TV", 
                       "VisionTV", 
                       "Arabesque", 
                       "Al Jazeera Sport", 
                       "Mobistar", 
                       "TeleSat", 
                       "ADD", 
                       "Kabelkiosk", 
                       "NTV"]                       
                           

caid_bouquets       = ["0919,093B,09CD", 
                       "183D", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0", 
                       "0"]


appInfo            = "getchannels.py rel.0.3.0.0 - python script to generate channels.conf file " + \
                     "from KingOfSat informations on 13E \n\n" + \
                     " to generate list of all 13E channels please use:\n\n" + \
                     " $ python getchannels.py <path of file to generate>\n\n" + \
                     " if you want only your pref channels in output file, please edit config file\n" + \
                     " and use --useconfig command line argument:\n\n" + \
                     " $ python getchannels.py --useconfig <path of file to generate>\n\n"

dict_channels      = {}
configFile         = "getchannels.conf"
outputList         = list()
cfgFile            = ""
outFileName        = ""
outputStr          = ""
isFilterUsed       = 0


# check for command line arguments
if len(sys.argv) < 2 or len(sys.argv) > 3:
    sys.exit("wrong arguments !!\n" + appInfo)

# print application informations
if sys.argv[1].strip().lower() == "--version" or sys.argv[1].strip().lower() == "-v" or \
   sys.argv[1].strip().lower() == "--help" or sys.argv[1].strip().lower() == "-h":
    print (appInfo)
    sys.exit(0)

# check for config file usage
if len(sys.argv) == 2 and sys.argv[1] == "--useconfig":
    sys.exit("wrong arguments !!\n" + appInfo)

if sys.argv[1] == "--useconfig":
    # config file used
    isFilterUsed = 1
    outFileName = sys.argv[2]
    
else:
    # set output file path
    outFileName = sys.argv[1]



# extract audio pid info from each audio pid
def RetAudioPidInfo(strInfo):
    outinfo = ""
    
    # parse audio type
    if string.find(strInfo, "title=\"AC3") > 0:
        outinfo = "@106"
    else:
        outinfo = "@4"
    
    
    # parse language name
    if string.find(strInfo, "title=\"Italiano") > 0:
        outinfo = "ita" + outinfo
    elif string.find(strInfo, "title=\"Inglese") > 0:
        outinfo = "eng" + outinfo
    elif string.find(strInfo, "title=\"Polacco") > 0:
        outinfo = "pol" + outinfo
    elif string.find(strInfo, "title=\"Romeno") > 0:
        outinfo = "rom" + outinfo
    elif string.find(strInfo, "title=\"Farsi") > 0:
        outinfo = "far" + outinfo
    elif string.find(strInfo, "title=\"Portoghese") > 0:
        outinfo = "por" + outinfo
    elif string.find(strInfo, "title=\"Urdu") > 0:
        outinfo = "urd" + outinfo
    elif string.find(strInfo, "title=\"Francese") > 0:
        outinfo = "fra" + outinfo
    elif string.find(strInfo, "title=\"Tedesco") > 0:
        outinfo = "ger" + outinfo
    elif string.find(strInfo, "title=\"Arabo") > 0:
        outinfo = "ara" + outinfo
    elif string.find(strInfo, "title=\"Bengali") > 0:
        outinfo = "ben" + outinfo
    elif string.find(strInfo, "title=\"Tamil") > 0:
        outinfo = "tam" + outinfo
    elif string.find(strInfo, "title=\"Russo") > 0:
        outinfo = "rus" + outinfo
    elif string.find(strInfo, "title=\"Turco") > 0:
        outinfo = "tur" + outinfo
    elif string.find(strInfo, "title=\"Curdo") > 0:
        outinfo = "kur" + outinfo
    elif string.find(strInfo, "title=\"Afghan") > 0:
        outinfo = "afg" + outinfo
    elif string.find(strInfo, "title=\"Ceco") > 0:
        outinfo = "cze" + outinfo
    elif string.find(strInfo, "title=\"Ungherese") > 0:
        outinfo = "hun" + outinfo
    elif string.find(strInfo, "title=\"Olandese") > 0:
        outinfo = "ned" + outinfo
    elif string.find(strInfo, "title=\"Spagnolo") > 0:
        outinfo = "esp" + outinfo
    elif string.find(strInfo, "title=\"Macedone") > 0:
        outinfo = "mac" + outinfo
    elif string.find(strInfo, "title=\"Tailandese") > 0:
        outinfo = "tha" + outinfo
    elif string.find(strInfo, "title=\"Vietnamita") > 0:
        outinfo = "vie" + outinfo
    elif string.find(strInfo, "title=\"Greco") > 0:
        outinfo = "gre" + outinfo
    elif string.find(strInfo, "title=\"Somali") > 0:
        outinfo = "som" + outinfo
    elif string.find(strInfo, "title=\"Berbere") > 0:
        outinfo = "ber" + outinfo
    elif string.find(strInfo, "title=\"Azero") > 0:
        outinfo = "aze" + outinfo
    else:
        outinfo = "oth" + outinfo
    
    return outinfo




# Elab all audio pid string
def RetAudioPid(strPid):
    
    outAudioPid=""
    pidstop = 0
    
    # generate array of all audio pids sections
    audiopids = strPid.split("<br")
    
    # loop for each audio pid
    for audiopid in audiopids:
        # process audio pid section     
        pidstart = string.find(audiopid, ">")
        pidstop  = string.find(audiopid, "<", pidstart+1)
        
        # check for characters next pid
        if pidstop < 0:
            # there is only audio pid in string section
            tmpapid=audiopid[pidstart+1:].replace("&nbsp;", "").strip()
        else:
            # there are other info in audio pid string
            tmpapid=audiopid[pidstart+1:pidstop].replace("&nbsp;", "").strip()
        
        tmpapid = tmpapid.split(" ")[0]
        
        # retrieve other audio pid info from remaining characters
        tmpapid+="=" + RetAudioPidInfo(audiopid[pidstop:]) + ","
        
        # update audio pids output string
        outAudioPid+=tmpapid
    
    # remove latest character (comma) from output string
    outAudioPid = outAudioPid[0:len(outAudioPid)-1]
    
    return outAudioPid

        



# parse config file to create output structure
def ParseConfigFile():
    global outputList
    global cfgFile
    
    # generate list with config file rows
    rows = cfgFile.split("\n")
    
    # remove empty rows and comments
    for row in rows:
        row = row.strip()
        if len(row) > 0:
            if row[0:1] != "#":
                outputList.append(row)



        




# method to extract channels info from webpage content
def ParseWebContent(webcode, bouquet, caid):
    
    global outputStr
    global isFilterUsed
    global outputList
    
    offSet1=0
    offSet2=0
    freq=""
    polar=""
    dvb=""
    modular=""
    sr=""
    fec=""
    nid=""
    tid=""
    tmpRow = ""
    
    # loop for all webpage content
    offSet1 = string.find(webcode, "<td width=\"5%\" class=\"bld\">")
    offSet1check = string.find(webcode, "<td width=\"5%\" class=\"nbld\">")
    if offSet1check > 0 and offSet1check < offSet1:
        offSet1 = offSet1check+1
    
    while offSet1 >= 0:
        # get frequency
        offSet2 = string.find(webcode, ".", offSet1+27)
        freq = webcode[offSet1+27:offSet2]
        
        # polarity
        offSet1 = string.find(webcode, "class=\"bld\">", offSet2+1)        
        offSet1check = string.find(webcode, "class=\"nbld\">", offSet2+1)   
        if offSet1check > 0 and offSet1check < offSet1:
            offSet1 = offSet1check+1

        offSet2 = string.find(webcode, "</td>", offSet1+12)
        polar = webcode[offSet1+12:offSet2]
        
        # dvb
        offSet1 = string.find(webcode, "DVB-", offSet2+1)
        offSet2 = string.find(webcode, "</td>", offSet1+4)
        dvb = webcode[offSet1+4:offSet2]
        
        # modular
        offSet1 = string.find(webcode, "\">", offSet2+1)
        offSet2 = string.find(webcode, "</td>", offSet1+2)
        modular = webcode[offSet1+2:offSet2]

        # symbol rate
        offSet1 = string.find(webcode, "class=\"bld\">", offSet2+1)
        offSet1check = string.find(webcode, "class=\"nbld\">", offSet2+1)   
        if offSet1check > 0 and offSet1check < offSet1:
            offSet1 = offSet1check+1
            
        offSet2 = string.find(webcode, "</a>", offSet1+12)
        sr = webcode[offSet1+12:offSet2]
        
        # fec
        offSet1 = string.find(webcode, "class=\"bld\">", offSet2+1)
        offSet1check = string.find(webcode, "class=\"nbld\">", offSet2+1)   
        if offSet1check > 0 and offSet1check < offSet1:
            offSet1 = offSet1check+1        
        
        offSet2 = string.find(webcode, "</a>", offSet1+12)
        fec = webcode[offSet1+12:offSet2]

        # network id
        offSet1 = string.find(webcode, "NID:", offSet2+1)
        offSet2 = string.find(webcode, "</td>", offSet1+4)
        nid = webcode[offSet1+4:offSet2]
        nid = nid.replace("<a class=\"n\">", "")
        nid = nid.replace("</a>", "").strip()
        
        
        # trasponder id
        offSet1 = string.find(webcode, "TID:", offSet2+1)
        offSet2 = string.find(webcode, "</td>", offSet1+4)
        tid = webcode[offSet1+4:offSet2]
        tid = tid.replace("<a class=\"n\">", "")
        tid = tid.replace("</a>", "").strip()

        
        # check for other channels in trasponder
        nextCh = string.find(webcode, " title=\"Id: ", offSet2+1)
        nextTs = string.find(webcode, "<td width=\"5%\" class=\"bld\">", offSet2+1)
        offSet1check = string.find(webcode, "<td width=\"5%\" class=\"nbld\">", offSet2+1)
        if offSet1check > 0 and offSet1check < nextTs:
            nextTs = offSet1check+1
            
        # check for end of channels
        if nextCh < 0:
            break
        
        # loop for all contained channels
        while ((nextCh < nextTs) and nextTs > 0) or (nextTs < 0) :
            # channel id
            offSet1 = nextCh
            offSet2 = string.find(webcode, "\"", offSet1+12)
            chName = webcode[offSet1+12:offSet2]
            newCh = string.find(webcode, " title=\"Id: ", offSet2+1)

            # channel number
            offSet1 = string.find(webcode, "class=\"s\">", offSet2+1)
            offSet2 = string.find(webcode, "</TD>", offSet1+10)
            chNum = webcode[offSet1+10:offSet2]
            
            # video pid
            offSet1 = string.find(webcode, ">", offSet2+10)
            offSet2 = string.find(webcode, "<", offSet1+1)
            vpid = webcode[offSet1+1:offSet2].strip()
            
            # audio pids
            offSet1 = string.find(webcode, "<TD WIDTH=", offSet2+1)
            offSet2 = string.find(webcode, "</TD>", offSet1+10)
            apidcode = webcode[offSet1+10:offSet2]
            
            # parse audio pid string to obtain data in vdr format
            apid = RetAudioPid(apidcode)
            
            
            # PCR            
            offSet1 = string.find(webcode, "<TD WIDTH=", offSet2+4)
            offSet1 = string.find(webcode, "<TD WIDTH=", offSet1+10)
            offSet1 = string.find(webcode, ">", offSet1+4)            
            offSet2 = string.find(webcode, "<", offSet1+1)
            pcr = webcode[offSet1+1:offSet2].strip().replace("&nbsp;", "")
            
            # update video pid with pcr parameter if required
            if (pcr != vpid):
                vpid += "+" + pcr
            
            
            # Subtitles
            offSet1 = string.find(webcode, "<TD WIDTH=", offSet2+1)
            offSet1 = string.find(webcode, ">", offSet1+4)
            offSet2 = string.find(webcode, "<", offSet1+1)
            sbtxt = webcode[offSet1+1:offSet2].strip().replace("&nbsp;", "")
            
            if sbtxt == "":
                sbtxt = "0"
            
            
            # create channels.conf row
            tmpRow = chName + ";" + bouquet + ":" + freq + ":" + polar.lower() + "C" + fec.replace("/","")
            
            # check for dvb-s type
            if dvb == "S2":
                # update row and video pid with dvb-s2 parameters
                tmpRow += "M5O35S1"
                vpid+="=27"
            else:
                # update row and video pid with dvb-s parameters
                tmpRow += "M2S0"
                vpid+="=2"
            
            # append data to generated channel row
            tmpRow += ":S13.0E:" + sr + ":" + vpid + ":" + apid + ":" + sbtxt + ":" + caid + ":" + chNum + ":" + nid + ":" + tid + ":0"

            
            # if config file is required
            if isFilterUsed == 1:
                # update row for channels in config file
                try:
                    idx = outputList.index(chName + ";" + bouquet)
                except ValueError:
                    idx = -1

                if idx >= 0:
                    outputList[idx] = tmpRow
            
            else:
                # update output string
                outputStr += tmpRow + "\r\n"
            
            
            # check for other channels in trasponder
            nextCh = string.find(webcode, " title=\"Id: ", offSet2+1)            
            nextTs = string.find(webcode, "<td width=\"5%\" class=\"bld\">", offSet2+1)
        
            # check for end of channels
            if nextCh < 0:
                break
        
        
        # go to next trasponder info
        offSet1 = nextTs




# read and parse config file if is required
if isFilterUsed == 1:
    # read config file
    file = open(configFile, "r")
    cfgFile = file.read()
    file.close()


    # Prepare output list
    ParseConfigFile()







# loop for each bouquet
for index in range(len(web_urls)):
    # add header info
    outputStr += "\r\n\r\n:[ " + web_bouquets[index] + " ]\r\n"
    
    # extract bouquet data from webpage contents
    f = urllib.urlopen(web_urls[index])
    webContent = f.read()
    f.close()
    ParseWebContent(webContent, web_bouquets[index], caid_bouquets[index])



# read and parse config file if is required
if isFilterUsed == 1:
    outputStr = ""
    # update output string
    for item in outputList:
        outputStr += item + "\n"


# write data in to output file
file = open(outFileName, "w")
file.write(outputStr)
file.close()




